function II2D=DCT_inverse(I)

[M N]=size(I);

if ( (M ~= 4) || (N ~= 4) )
    fprintf(1,'\n DIM deben ser 4x4 (%d x %d).\n',M, N);
    return;
end

I_1D=zeros(4,4);

% First 1D
for fila=1:4
    IT(1)=I(fila,1)+I(fila,3);
    IT(2)=I(fila,1)-I(fila,3);
    IT(3)=floor(I(fila,2)/2)-I(fila,4);
    IT(4)=I(fila,2)+floor(I(fila,4)/2);
    
    I_1D(fila,1)=IT(1)+IT(4);
    I_1D(fila,2)=IT(2)+IT(3);
    I_1D(fila,3)=IT(2)-IT(3);
    I_1D(fila,4)=IT(1)-IT(4);
end

% First 1D
for col=1:4
    IT(1)=I_1D(1,col)+I_1D(3,col);
    IT(2)=I_1D(1,col)-I_1D(3,col);
    IT(3)=floor(I_1D(2,col)/2)-I_1D(4,col);
    IT(4)=I_1D(2,col)+floor(I_1D(4,col)/2);
    
    I2D_I(1,col)=IT(1)+IT(4);
    I2D_I(2,col)=IT(2)+IT(3);
    I2D_I(3,col)=IT(2)-IT(3);
    I2D_I(4,col)=IT(1)-IT(4);
end

II2D=round(I2D_I/64);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%                                                              %%
%% COMPRESION DE VIDEO                                          %%
%% Grado en Ingeniera de Tecnologas de Telecomunicacin       %%
%% Gustavo A. Ruiz Robredo                                      %%
%% ruizrg@unican.es                                             %%
%%                                                              %%
%% uu   uu  cccccc   UNIVERSIDAD DE CANTABRIA                   %%
%% uu   uu  cccccc   Dpto. INGENIERIA INFORMATICA Y ELECTRONICA %%
%% uu   uu  cc       FACULTAD DE CIENCIAS                       %%
%%  uuuuu   cccccc   Avda. Los Castros s/n                      %%
%%   uuu    cccccc   39005-SANTANDER (SPAIN)                    %%
%%                                                              %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
