function test_block_cavlc_H264(Z)

warning off;

load table;
global Table_coeff0 Table_coeff1 Table_coeff2 Table_coeff3
global Table_run Table_zeros

% Secuencia de coeficientes cuantificados
% Z=[3 0 0 0; 0 0 0 0; 0 0 0 0; 0 0 0 0];
% Z=[0 3 0 0; 0 0 0 0; 0 0 0 0; 0 0 0 0];
% Z=[0 3 -1 0; 0 -1 1 0; 1 0 0 0; 0 0 0 0];
% fprintf('\n COEFICIENTES CUANTIFICADOS BLOQUE 4x4:\n');
% disp(Z);

fprintf('\n COEFICIENTES CAVLC:\n');
disp(Z);
fprintf('\n');

%QP = 10;
bits = '';
[h,w]=size(Z);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% CODIFICACION CAVLC
for i=1:4:h
    for j=1:4:w
        fprintf('\n ===========================');
        fprintf('\n BLOQUE 4x4: %d %d',(i-1)/4,(j-1)/4);
        Z4x4 = Z(i:i+3,j:j+3);
        fprintf('\n COEFICIENTES:\n');
        disp(Z4x4);
        
        % Codificacion
        [bits_new] = enc_cavlc(Z4x4, 0, 0);
        bits_cavlc = [bits bits_new];
        
        fprintf('\n CODIFICACION CAVLC (%d bits): %s\n',length(bits_cavlc),bits_cavlc);
        
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        % DECODIFICACION CAVLC
        k=1;
        while (k<=length(bits_cavlc))
            [data,m] = dec_cavlc(bits_cavlc(k:length(bits_cavlc)),0,0);
%             fprintf('\n COEFICIENTES DECUANTIFICADOS BLOQUE:\n');
%             disp(data);
            Z_r(i:i+3,j:j+3) = data;
            k = k + m - 1;
        end
    end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%                                                              %%
%% COMPRESION DE VIDEO                                          %%
%% Grado en Ingeniera de Tecnologas de Telecomunicacin       %%
%% Gustavo A. Ruiz Robredo                                      %%
%% ruizrg@unican.es                                             %%
%%                                                              %%
%% uu   uu  cccccc   UNIVERSIDAD DE CANTABRIA                   %%
%% uu   uu  cccccc   Dpto. INGENIERIA INFORMATICA Y ELECTRONICA %%
%% uu   uu  cc       FACULTAD DE CIENCIAS                       %%
%%  uuuuu   cccccc   Avda. Los Castros s/n                      %%
%%   uuu    cccccc   39005-SANTANDER (SPAIN)                    %%
%%                                                              %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


